function [zeroes,slope,offs] = zero_lin_2(xfeat,yfeat,N)
% function [zeroes,slope,offs] = zero_lin_2(xfeat,yfeat,N)
%
% detects zeros of 2D vectorfield (xfeat,yfeat) in window of size NxN
% using linear regression.

% Copyright (c) 2003 Michael Felsberg
% $Revision: 1.0 $  $Date: 2003/09/02 12:55:12 $
%
%    This program is free software; you can redistribute it and/or modify
%    it under the terms of the GNU General Public License as published by
%    the Free Software Foundation; either version 2 of the License, or
%    (at your option) any later version.
%
%    This program is distributed in the hope that it will be useful,
%    but WITHOUT ANY WARRANTY; without even the implied warranty of
%    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%    GNU General Public License for more details.
%
%    You should have received a copy of the GNU General Public License
%    along with this program; if not, write to the Free Software
%    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Nh=floor(N/2);
Ns=N^2;
c=meshgrid(-Nh:Nh);
x=reshape(c',1,Ns);
y=reshape(c,1,Ns);
X=[x+i*y; ones(1,Ns)];
XP=pinv(X');
fm1=reshape(XP(1,:),N,N);
fm2=reshape(XP(2,:),N,N);
slope=-imag(conv2(xfeat+i*yfeat,fm1,'same'));
offs=conv2(xfeat+i*yfeat,fm2,'same');
dist=abs(offs)./(abs(slope)+eps);
zeroes=(dist<sqrt(2)).*(1-dist.^2./2);
